# SCHEDULE NEXT TICK
schedule function nimajnebec:demimortality/main 1t

# ON TICK EVENTS
tag @a[tag=dm.dead,nbt={Health:20f}] remove dm.dead
execute as @a unless entity @s[scores={dm.id=-1..}] run function nimajnebec:demimortality/initialise_player
execute as @a[scores={dm.deaths=1..}] run function nimajnebec:demimortality/death_handling/die
execute as @a[scores={dm.lives=..0},gamemode=!spectator,gamemode=!creative] run function nimajnebec:demimortality/death_handling/switch_gamemode
execute at @e[tag=dm.soul] run particle totem_of_undying ~ ~0.5 ~ 0.1 0.1 0.1 0 1 normal
execute as @e[tag=dm.ritual] at @s run function nimajnebec:demimortality/rituals/ritual_loop

# RITUALS
execute if score #req_temple dm.dummy matches 1 as @e[type=item] at @s unless entity @e[tag=dm.ritual,distance=..1] if predicate nimajnebec:demimortality/ritual_check if predicate nimajnebec:demimortality/temple_check align xyz run function nimajnebec:demimortality/rituals/position_check
execute if score #req_temple dm.dummy matches 0 as @e[type=item] at @s unless entity @e[tag=dm.ritual,distance=..1] if predicate nimajnebec:demimortality/ritual_check align xyz run function nimajnebec:demimortality/rituals/ritual_type_check

# TRANSFUSION RITUAL
execute at @e[tag=dm.give_life] run particle firework ~ ~ ~ 0 0 0 0 1 force @a[distance=..50]
execute as @e[tag=dm.give_life] at @s facing entity @p[gamemode=!spectator,tag=!dm.dead] eyes run tp @s ~ ~ ~ ~45 ~
execute as @e[tag=dm.give_life] at @s run tp @s ^ ^ ^0.25
execute at @e[tag=dm.give_life] as @a[distance=..1.7,gamemode=!spectator,tag=!dm.dead] at @s run function nimajnebec:demimortality/rituals/transfusion/give_life

# RESURRECTION RITUAL
execute as @e[tag=dm.resurrection,scores={dm.dummy=1..}] at @s run function nimajnebec:demimortality/rituals/resurrection/timeline

# BOOGEYMAN CHECKS
execute as @a[tag=dm.boogey,scores={dm.kills=1..}] run function nimajnebec:demimortality/boogeyman/cure